//****************************************************************************//
// coremesh.h                                                                 //
// Copyright (C) 2001, 2002 Bruno 'Beosil' Heidelberger                       //
//****************************************************************************//
// This library is free software; you can redistribute it and/or modify it    //
// under the terms of the GNU Lesser General Public License as published by   //
// the Free Software Foundation; either version 2.1 of the License, or (at    //
// your option) any later version.                                            //
//****************************************************************************//

#pragma once

#include <boost/shared_ptr.hpp>
#include "cal3d/global.h"

typedef boost::shared_ptr<class CalCoreSubmesh> CalCoreSubmeshPtr;

class CAL3D_API CalCoreMesh : public Cal::Object
{
public:
  typedef std::vector<CalCoreSubmeshPtr> CalCoreSubmeshVector;

  size_t sizeInBytes() const;
  int addCoreSubmesh(const CalCoreSubmeshPtr& pCoreSubmesh);
  const CalCoreSubmeshPtr& getCoreSubmesh(int id) const {
      return m_vectorCoreSubmesh[id];
  }
  size_t getCoreSubmeshCount() const {
      return m_vectorCoreSubmesh.size();
  }
  CalCoreSubmeshVector& getVectorCoreSubmesh();
  int addAsMorphTarget(CalCoreMesh *pCoreMesh, std::string const & morphTargetName);
  void scale(float factor);

  CalCoreSubmeshVector m_vectorCoreSubmesh;
};
